/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package javafxballmotion;

import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import jfxsprites.Sprite;

/**
 *
 * @author hussmann
 */
 class BallSprite extends Sprite {
        
    private double radius;

    public BallSprite(double posx, double posy, double vx, double vy, double r, Color c) {
        // reference for posx, posy and update() is center of circle
        super(new Circle(r, c));
        radius = r;
        n.setTranslateX(posx);
        n.setTranslateY(posy);
        this.vx = vx;
        this.vy = vy;
    }

    public void handleCollision(Sprite other) {
        if (other instanceof BallSprite) {
            Circle c1 = (Circle)this.getNode();
            Circle c2 = (Circle)other.getNode();
            double r1 = c1.getRadius();
            double r2 = c2.getRadius();
            double vx1 = this.getVelocityX();
            double vx2 = other.getVelocityX();
            double vy1 = this.getVelocityY();
            double vy2 = other.getVelocityY();
            double dx = c1.getTranslateX()-c2.getTranslateX();
            double dy = c1.getTranslateY()-c2.getTranslateY();
            double angle = Math.atan2(dy,dx);
            double dist = Math.sqrt(dx*dx + dy*dy);
            if (dist < r1+r2) {
                double cosa = Math.cos(angle);
                double sina = Math.sin(angle);
                System.out.println("cosa="+cosa+" sina="+sina);
                double overshoot = r1+r2-dist;
                double overshootX = overshoot*cosa;
                double overshootY = overshoot*sina;
                System.out.println("overshoot= "+overshoot+" dx="+dx+" dy="+dy+" x1="+c1.getTranslateX()+" y1="+c1.getTranslateY()+" x2="+c2.getTranslateX()+" y2="+c2.getTranslateY());
                double x1New = c1.getTranslateX()+overshootX/2;
                double y1New = c1.getTranslateY()+overshootY/2;
                double x2New = c2.getTranslateX()-overshootX/2;
                double y2New = c2.getTranslateY()-overshootY/2;
                System.out.println("x1N="+x1New+" y1N="+y1New+" x2N="+x2New+" y2N="+y2New);
                double dxNew = x2New-x1New;
                double dyNew = y2New-y1New;
                System.out.println("New distance: "+Math.sqrt(dxNew*dxNew+dyNew*dyNew));
                c1.setTranslateX(x1New);
                c1.setTranslateY(y1New);
                c2.setTranslateX(x2New);
                c2.setTranslateY(y2New); 
                double px1 = cosa*vx1+sina*vy1;
                double py1 = cosa*vx1-sina*vy1;
                double px2 = cosa*vx2+sina*vy2;
                double py2 = cosa*vx2-sina*vy2;
                double vxNew1 = cosa*px2-sina*py2;
                double vyNew1 = cosa*px2+sina*py2;
                double vxNew2 = cosa*px1-sina*py1;
                double vyNew2 = cosa*px1+sina*py1;                
                this.setVelocityX(vxNew1*Sprite.BOUNCELOSS);
                this.setVelocityY(vyNew1*Sprite.BOUNCELOSS);
                other.setVelocityX(vxNew2*Sprite.BOUNCELOSS);
                other.setVelocityY(vyNew2*Sprite.BOUNCELOSS);
            }
        }
    }
}

