/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package javafxballmotion;

import javafx.animation.*;
import javafx.application.Application;
import javafx.collections.*;
import javafx.event.*;
import javafx.scene.*;
import javafx.scene.paint.Color;
import javafx.scene.shape.*;
import javafx.stage.Stage;
import javafx.util.Duration;
import jfxsprites.*;

/**
 *
 * @author hussmann
 */
public class JavaFXBallMotion extends Application {
    static final int scW = 640;
    static final int scH = 280;
               
    @Override
    public void start(Stage primaryStage) {
        
        final int r = 40;
        
        Group root = new Group();       
        Scene scene = new Scene(root, scW, scH, Color.WHITE);
        SpriteManager sprites = new SpriteManager(scW, scH);
                
        BallSprite ball1 = new BallSprite(40, 40, 20, 10, r, Color.RED);
        sprites.addSprite(ball1);
        root.getChildren().add(ball1.getNode());
        
        BallSprite ball2 = new BallSprite(300, 200, -15, -15, r, Color.BLUE);
        sprites.addSprite(ball2);
        root.getChildren().add(ball2.getNode()); 
       
        Timeline timeline = new Timeline();
        timeline.setCycleCount(Timeline.INDEFINITE);
        KeyFrame updateNodes = new KeyFrame(Duration.millis(20),
              new EventHandler<ActionEvent>() {
                  public void handle(ActionEvent event) {
                      sprites.updateSprites();
                  }
              });
        timeline.getKeyFrames().add(updateNodes);
               
        primaryStage.setTitle("JavaFX Basic Ball Motion");
        primaryStage.setScene(scene);
        primaryStage.sizeToScene();
        primaryStage.show();
        timeline.play();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
