/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jfxsprites;

import javafx.scene.Node;

/**
 *
 * @author hussmann
 */
public abstract class Sprite {
        
    public static final double MINSPEED = 0.1;
    public static final double BOUNCELOSS = 0.95;
    public static final double FRICTLOSS = 0.999;

    
    protected Node n;
    protected double vx;
    protected double vy;
    private double maxX;
    private double maxY;

    public Sprite(Node n) {
        this.n = n;
    }

    public Node getNode() {
        return n;
    }
    
    public void setMaxX(double value) {
        this.maxX = value;
    }

    public void setMaxY(double value) {
        this.maxY = value;
    }
    
     public double getVelocityX() {
        return this.vx;
    }

    public void setVelocityX (double vx) {
        this.vx = vx;
    }

    public double getVelocityY() {
        return this.vy;
    }

    public void setVelocityY (double vy) {
        this.vy = vy;
    }

    public void update() {
    //    System.out.println(bounceLoss+"|"+vx+","+vy+"|"+n.getTranslateX()+","+n.getTranslateY()+"|| maxX:"+n.getBoundsInParent().getMaxX()+",minX:"+n.getBoundsInParent().getMinX()+",maxY:"+n.getBoundsInParent().getMaxY()+",minY:"+n.getBoundsInParent().getMinY());
        double overshootHR = n.getBoundsInParent().getMaxX()-maxX;
        double overshootHL = n.getBoundsInParent().getMinX();
        double overshootVD = n.getBoundsInParent().getMaxY()-maxY;
        double overshootVU = n.getBoundsInParent().getMinY();
        if (overshootHR > 0) {
            n.setTranslateX(n.getTranslateX()-overshootHR);
        }
        if (overshootHL < 0) {
            n.setTranslateX(n.getTranslateX()-overshootHL);
        }
        if (overshootVD > 0) {
            n.setTranslateY(n.getTranslateY()-overshootVD);
        }
        if (overshootVU < 0) {
            n.setTranslateY(n.getTranslateY()-overshootVU);
        }
        if (overshootHR > 0 || overshootHL < 0) {
            vx = -vx*BOUNCELOSS;
        }
        if (overshootVD > 0 || overshootVU < 0) {
            vy = -vy*BOUNCELOSS;
        }
        vx = FRICTLOSS*vx;
        vy = FRICTLOSS*vy;
            double effSpeed = Math.sqrt(vx*vx+vy*vy);
            if (effSpeed < MINSPEED) {
                vx = 0;
                vy = 0;
            }
        n.setTranslateX(n.getTranslateX()+vx);
        n.setTranslateY(n.getTranslateY()+vy);
    }
    
    abstract public void handleCollision(Sprite other);
}
